/* Definition of a finite state machine for a subset of HTTP 4.1
 * Auto generated by generate_fsm.py. Please do not edit.
 */

#define HTMLPARSER_NUM_STATES 33

enum htmlparser_state_internal_enum {
  HTMLPARSER_STATE_INT_TEXT,
  HTMLPARSER_STATE_INT_TAG_START,
  HTMLPARSER_STATE_INT_TAG_NAME,
  HTMLPARSER_STATE_INT_DECLARATION_START,
  HTMLPARSER_STATE_INT_DECLARATION_BODY,
  HTMLPARSER_STATE_INT_COMMENT_OPEN,
  HTMLPARSER_STATE_INT_COMMENT_BODY,
  HTMLPARSER_STATE_INT_COMMENT_DASH,
  HTMLPARSER_STATE_INT_COMMENT_DASH_DASH,
  HTMLPARSER_STATE_INT_PI,
  HTMLPARSER_STATE_INT_PI_MAY_END,
  HTMLPARSER_STATE_INT_TAG_SPACE,
  HTMLPARSER_STATE_INT_TAG_CLOSE,
  HTMLPARSER_STATE_INT_ATTR,
  HTMLPARSER_STATE_INT_ATTR_SPACE,
  HTMLPARSER_STATE_INT_VALUE,
  HTMLPARSER_STATE_INT_VALUE_TEXT,
  HTMLPARSER_STATE_INT_VALUE_Q_START,
  HTMLPARSER_STATE_INT_VALUE_Q,
  HTMLPARSER_STATE_INT_VALUE_DQ_START,
  HTMLPARSER_STATE_INT_VALUE_DQ,
  HTMLPARSER_STATE_INT_CDATA_COMMENT_START,
  HTMLPARSER_STATE_INT_CDATA_COMMENT_START_DASH,
  HTMLPARSER_STATE_INT_CDATA_COMMENT_BODY,
  HTMLPARSER_STATE_INT_CDATA_COMMENT_DASH,
  HTMLPARSER_STATE_INT_CDATA_COMMENT_DASH_DASH,
  HTMLPARSER_STATE_INT_CDATA_TEXT,
  HTMLPARSER_STATE_INT_CDATA_LT,
  HTMLPARSER_STATE_INT_CDATA_MAY_CLOSE,
  HTMLPARSER_STATE_INT_JS_FILE,
  HTMLPARSER_STATE_INT_CSS_FILE,
  HTMLPARSER_STATE_INT_NULL
};

static const int htmlparser_states_external[] = {
  HTMLPARSER_STATE_TEXT,
  HTMLPARSER_STATE_TAG,
  HTMLPARSER_STATE_TAG,
  HTMLPARSER_STATE_TEXT,
  HTMLPARSER_STATE_TEXT,
  HTMLPARSER_STATE_TEXT,
  HTMLPARSER_STATE_COMMENT,
  HTMLPARSER_STATE_COMMENT,
  HTMLPARSER_STATE_COMMENT,
  HTMLPARSER_STATE_TEXT,
  HTMLPARSER_STATE_TEXT,
  HTMLPARSER_STATE_TAG,
  HTMLPARSER_STATE_TEXT,
  HTMLPARSER_STATE_ATTR,
  HTMLPARSER_STATE_ATTR,
  HTMLPARSER_STATE_VALUE,
  HTMLPARSER_STATE_VALUE,
  HTMLPARSER_STATE_VALUE,
  HTMLPARSER_STATE_VALUE,
  HTMLPARSER_STATE_VALUE,
  HTMLPARSER_STATE_VALUE,
  HTMLPARSER_STATE_TEXT,
  HTMLPARSER_STATE_TEXT,
  HTMLPARSER_STATE_TEXT,
  HTMLPARSER_STATE_TEXT,
  HTMLPARSER_STATE_TEXT,
  HTMLPARSER_STATE_TEXT,
  HTMLPARSER_STATE_TEXT,
  HTMLPARSER_STATE_TEXT,
  HTMLPARSER_STATE_JS_FILE,
  HTMLPARSER_STATE_CSS_FILE,
  HTMLPARSER_STATE_TEXT
};

static const struct statetable_transitions_s htmlparser_state_transitions[] = {
  { "[:default:]", HTMLPARSER_STATE_INT_NULL, HTMLPARSER_STATE_INT_NULL },
  { "[:default:]", HTMLPARSER_STATE_INT_CSS_FILE, HTMLPARSER_STATE_INT_CSS_FILE },
  { "[:default:]", HTMLPARSER_STATE_INT_JS_FILE, HTMLPARSER_STATE_INT_JS_FILE },
  { "[:default:]", HTMLPARSER_STATE_INT_CDATA_MAY_CLOSE, HTMLPARSER_STATE_INT_CDATA_TEXT },
  { " \t\n\r", HTMLPARSER_STATE_INT_CDATA_MAY_CLOSE, HTMLPARSER_STATE_INT_TAG_SPACE },
  { ">", HTMLPARSER_STATE_INT_CDATA_MAY_CLOSE, HTMLPARSER_STATE_INT_TEXT },
  { "A-Za-z0-9/_:-", HTMLPARSER_STATE_INT_CDATA_MAY_CLOSE, HTMLPARSER_STATE_INT_CDATA_MAY_CLOSE },
  { "[:default:]", HTMLPARSER_STATE_INT_CDATA_LT, HTMLPARSER_STATE_INT_CDATA_TEXT },
  { "!", HTMLPARSER_STATE_INT_CDATA_LT, HTMLPARSER_STATE_INT_CDATA_COMMENT_START },
  { "/", HTMLPARSER_STATE_INT_CDATA_LT, HTMLPARSER_STATE_INT_CDATA_MAY_CLOSE },
  { "[:default:]", HTMLPARSER_STATE_INT_CDATA_TEXT, HTMLPARSER_STATE_INT_CDATA_TEXT },
  { "<", HTMLPARSER_STATE_INT_CDATA_TEXT, HTMLPARSER_STATE_INT_CDATA_LT },
  { "[:default:]", HTMLPARSER_STATE_INT_CDATA_COMMENT_DASH_DASH, HTMLPARSER_STATE_INT_CDATA_COMMENT_BODY },
  { ">", HTMLPARSER_STATE_INT_CDATA_COMMENT_DASH_DASH, HTMLPARSER_STATE_INT_CDATA_TEXT },
  { "-", HTMLPARSER_STATE_INT_CDATA_COMMENT_DASH_DASH, HTMLPARSER_STATE_INT_CDATA_COMMENT_DASH_DASH },
  { "[:default:]", HTMLPARSER_STATE_INT_CDATA_COMMENT_DASH, HTMLPARSER_STATE_INT_CDATA_COMMENT_BODY },
  { "-", HTMLPARSER_STATE_INT_CDATA_COMMENT_DASH, HTMLPARSER_STATE_INT_CDATA_COMMENT_DASH_DASH },
  { "[:default:]", HTMLPARSER_STATE_INT_CDATA_COMMENT_BODY, HTMLPARSER_STATE_INT_CDATA_COMMENT_BODY },
  { "-", HTMLPARSER_STATE_INT_CDATA_COMMENT_BODY, HTMLPARSER_STATE_INT_CDATA_COMMENT_DASH },
  { "[:default:]", HTMLPARSER_STATE_INT_CDATA_COMMENT_START_DASH, HTMLPARSER_STATE_INT_CDATA_TEXT },
  { "-", HTMLPARSER_STATE_INT_CDATA_COMMENT_START_DASH, HTMLPARSER_STATE_INT_CDATA_COMMENT_BODY },
  { "[:default:]", HTMLPARSER_STATE_INT_CDATA_COMMENT_START, HTMLPARSER_STATE_INT_CDATA_TEXT },
  { "-", HTMLPARSER_STATE_INT_CDATA_COMMENT_START, HTMLPARSER_STATE_INT_CDATA_COMMENT_START_DASH },
  { "[:default:]", HTMLPARSER_STATE_INT_VALUE_DQ, HTMLPARSER_STATE_INT_VALUE_DQ },
  { "\"", HTMLPARSER_STATE_INT_VALUE_DQ, HTMLPARSER_STATE_INT_TAG_SPACE },
  { "[:default:]", HTMLPARSER_STATE_INT_VALUE_DQ_START, HTMLPARSER_STATE_INT_VALUE_DQ },
  { "\"", HTMLPARSER_STATE_INT_VALUE_DQ_START, HTMLPARSER_STATE_INT_TAG_SPACE },
  { "[:default:]", HTMLPARSER_STATE_INT_VALUE_Q, HTMLPARSER_STATE_INT_VALUE_Q },
  { "\'", HTMLPARSER_STATE_INT_VALUE_Q, HTMLPARSER_STATE_INT_TAG_SPACE },
  { "[:default:]", HTMLPARSER_STATE_INT_VALUE_Q_START, HTMLPARSER_STATE_INT_VALUE_Q },
  { "\'", HTMLPARSER_STATE_INT_VALUE_Q_START, HTMLPARSER_STATE_INT_TAG_SPACE },
  { "[:default:]", HTMLPARSER_STATE_INT_VALUE_TEXT, HTMLPARSER_STATE_INT_VALUE_TEXT },
  { " \t\n\r", HTMLPARSER_STATE_INT_VALUE_TEXT, HTMLPARSER_STATE_INT_TAG_SPACE },
  { ">", HTMLPARSER_STATE_INT_VALUE_TEXT, HTMLPARSER_STATE_INT_TAG_CLOSE },
  { "[:default:]", HTMLPARSER_STATE_INT_VALUE, HTMLPARSER_STATE_INT_VALUE_TEXT },
  { ">", HTMLPARSER_STATE_INT_VALUE, HTMLPARSER_STATE_INT_TAG_CLOSE },
  { " \t\n\r", HTMLPARSER_STATE_INT_VALUE, HTMLPARSER_STATE_INT_VALUE },
  { "\"", HTMLPARSER_STATE_INT_VALUE, HTMLPARSER_STATE_INT_VALUE_DQ_START },
  { "\'", HTMLPARSER_STATE_INT_VALUE, HTMLPARSER_STATE_INT_VALUE_Q_START },
  { "=", HTMLPARSER_STATE_INT_ATTR_SPACE, HTMLPARSER_STATE_INT_VALUE },
  { "/", HTMLPARSER_STATE_INT_ATTR_SPACE, HTMLPARSER_STATE_INT_TAG_SPACE },
  { "A-Za-z0-9_:-", HTMLPARSER_STATE_INT_ATTR_SPACE, HTMLPARSER_STATE_INT_ATTR },
  { " \t\n\r", HTMLPARSER_STATE_INT_ATTR_SPACE, HTMLPARSER_STATE_INT_ATTR_SPACE },
  { ">", HTMLPARSER_STATE_INT_ATTR_SPACE, HTMLPARSER_STATE_INT_TAG_CLOSE },
  { " \t\n\r", HTMLPARSER_STATE_INT_ATTR, HTMLPARSER_STATE_INT_ATTR_SPACE },
  { "=", HTMLPARSER_STATE_INT_ATTR, HTMLPARSER_STATE_INT_VALUE },
  { "/", HTMLPARSER_STATE_INT_ATTR, HTMLPARSER_STATE_INT_TAG_SPACE },
  { ">", HTMLPARSER_STATE_INT_ATTR, HTMLPARSER_STATE_INT_TAG_CLOSE },
  { "A-Za-z0-9_:-", HTMLPARSER_STATE_INT_ATTR, HTMLPARSER_STATE_INT_ATTR },
  { "[:default:]", HTMLPARSER_STATE_INT_TAG_CLOSE, HTMLPARSER_STATE_INT_TEXT },
  { "<", HTMLPARSER_STATE_INT_TAG_CLOSE, HTMLPARSER_STATE_INT_TAG_START },
  { "/", HTMLPARSER_STATE_INT_TAG_SPACE, HTMLPARSER_STATE_INT_TAG_SPACE },
  { "A-Za-z0-9_:-", HTMLPARSER_STATE_INT_TAG_SPACE, HTMLPARSER_STATE_INT_ATTR },
  { " \t\n\r", HTMLPARSER_STATE_INT_TAG_SPACE, HTMLPARSER_STATE_INT_TAG_SPACE },
  { ">", HTMLPARSER_STATE_INT_TAG_SPACE, HTMLPARSER_STATE_INT_TAG_CLOSE },
  { "[:default:]", HTMLPARSER_STATE_INT_PI_MAY_END, HTMLPARSER_STATE_INT_PI },
  { ">", HTMLPARSER_STATE_INT_PI_MAY_END, HTMLPARSER_STATE_INT_TEXT },
  { "[:default:]", HTMLPARSER_STATE_INT_PI, HTMLPARSER_STATE_INT_PI },
  { "?", HTMLPARSER_STATE_INT_PI, HTMLPARSER_STATE_INT_PI_MAY_END },
  { "[:default:]", HTMLPARSER_STATE_INT_COMMENT_DASH_DASH, HTMLPARSER_STATE_INT_COMMENT_BODY },
  { ">", HTMLPARSER_STATE_INT_COMMENT_DASH_DASH, HTMLPARSER_STATE_INT_TEXT },
  { "-", HTMLPARSER_STATE_INT_COMMENT_DASH_DASH, HTMLPARSER_STATE_INT_COMMENT_DASH_DASH },
  { "[:default:]", HTMLPARSER_STATE_INT_COMMENT_DASH, HTMLPARSER_STATE_INT_COMMENT_BODY },
  { "-", HTMLPARSER_STATE_INT_COMMENT_DASH, HTMLPARSER_STATE_INT_COMMENT_DASH_DASH },
  { "[:default:]", HTMLPARSER_STATE_INT_COMMENT_BODY, HTMLPARSER_STATE_INT_COMMENT_BODY },
  { "-", HTMLPARSER_STATE_INT_COMMENT_BODY, HTMLPARSER_STATE_INT_COMMENT_DASH },
  { "[:default:]", HTMLPARSER_STATE_INT_COMMENT_OPEN, HTMLPARSER_STATE_INT_TEXT },
  { "-", HTMLPARSER_STATE_INT_COMMENT_OPEN, HTMLPARSER_STATE_INT_COMMENT_BODY },
  { "[:default:]", HTMLPARSER_STATE_INT_DECLARATION_BODY, HTMLPARSER_STATE_INT_DECLARATION_BODY },
  { ">", HTMLPARSER_STATE_INT_DECLARATION_BODY, HTMLPARSER_STATE_INT_TEXT },
  { "[:default:]", HTMLPARSER_STATE_INT_DECLARATION_START, HTMLPARSER_STATE_INT_DECLARATION_BODY },
  { ">", HTMLPARSER_STATE_INT_DECLARATION_START, HTMLPARSER_STATE_INT_TEXT },
  { "-", HTMLPARSER_STATE_INT_DECLARATION_START, HTMLPARSER_STATE_INT_COMMENT_OPEN },
  { ">", HTMLPARSER_STATE_INT_TAG_NAME, HTMLPARSER_STATE_INT_TAG_CLOSE },
  { " \t\n\r", HTMLPARSER_STATE_INT_TAG_NAME, HTMLPARSER_STATE_INT_TAG_SPACE },
  { "A-Za-z0-9/_:-", HTMLPARSER_STATE_INT_TAG_NAME, HTMLPARSER_STATE_INT_TAG_NAME },
  { "!", HTMLPARSER_STATE_INT_TAG_START, HTMLPARSER_STATE_INT_DECLARATION_START },
  { "?", HTMLPARSER_STATE_INT_TAG_START, HTMLPARSER_STATE_INT_PI },
  { "A-Za-z0-9/_:-", HTMLPARSER_STATE_INT_TAG_START, HTMLPARSER_STATE_INT_TAG_NAME },
  { "[:default:]", HTMLPARSER_STATE_INT_TEXT, HTMLPARSER_STATE_INT_TEXT },
  { "<", HTMLPARSER_STATE_INT_TEXT, HTMLPARSER_STATE_INT_TAG_START },
  { NULL, STATEMACHINE_ERROR, STATEMACHINE_ERROR }
};

